<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Constructors</title>
</head>

<body>
  <div class="wrap">
    <header>
      <form id="form">
        <label for="author">
          <span>Author</span>
          <select id="author" name="author">
            <option value="Taras Shevchenko">Taras Shevchenko</option>
            <option value="Ivan Franko">Ivan Franko</option>
            <option value="Vasyl Stys">Vasyl Stys</option>
            <option value="Oles Gonchar">Oles Gonchar</option>
          </select>
        </label>

        <label for="message">
          <span>Message</span>
          <textarea placeholder="Your Message" id="message"></textarea>
        </label>

        <button type="submit">Send Message</button>
      </form>
    </header>

    <section>
      <ul id="message_list">
      </ul>

    </section>

  </div>


  <script>
    /*
      Задание на классы.
  
      Создать класс Message конструктор котрого состоит из следующих полей:
      id, author, text, date, answers
  
      У этого класса будет два метода:
      SkipMessage() -> которое должно найти сообщение и удалить его из массива.
      AnswerMessage()-> должно отрыть поле ввода, в который вы сможете ввести ответ
      SendAnswer() -> метод который «отравляет» ответ, при этом обновляя поле ответа(answers) в вашем объекте с сообщением.
  
      В метод SendAnswer нужно передать обьект класса Answer который наследуется от класса Message,
      Но еще дополнительно будет иметь поле parentId.
  
  
      message = {
        id: '',
        author: '',
        text: '',
        date: '',
        answers: [
          {
            id: '',
            author: '',
            text: '',
            date: '',
            parentId: '',
            answers: ''
          }
        ]
      }
  
      +Bonus: После создании сообщение добавляется в массив со всеми сообщениями, которые потом будут выводится на экран.
  
      _ _ _
  
      Задание можно разбелить на две части:
        1. Создание самого сообщения:
        id->выдаётся автоматом
        Author-> селект с выбором автора
        Text -> текст сообщения
        date -> автоматически в момент создания
  
        Все данные беруться с формы. Массив с сообщениями передается в функцию рендера, которая генерирует сам список.
  
        2. Ответ на сообщение
  
    */

    document.addEventListener("DOMContentLoaded", function () {
      let form = document.getElementById("form");
      form.addEventListener('submit', sendMessageClick);

      let _latestId = 1;
      let messageArray = [];

      class Message {
        constructor(id, author, text, date, answers) {
          this.id = id;
          this.author = author;
          this.text = text;
          this.date = date;
          this.answers = answers;

          this.SendAnswer = this.SendAnswer.bind(this);
          this.renderMessage = this.renderMessage.bind(this);
          this.renderForm = this.renderForm.bind(this);
        }

        SkipMessage = () => {
          let li = document.getElementById(this.id);
          li.parentElement.removeChild(li);
        }

        AnswerMessage = () => {
          this.renderForm();
        }

        SendAnswer = (answer) => {
          // удаление формы
          let li = document.getElementById(this.id);
          let form = document.getElementById("form" + this.id);
          li.removeChild(form)

          // отображение ответа
          let ul = document.createElement("ul");
          li.appendChild(ul);
          answer.renderMessage(ul);
        }

        renderMessage(ul) {
          let li = document.createElement('li');
          li.id = this.id;
          li.innerHTML = `
            <div>
              <div class="message__date">
                ${this.date}
              </div>
              <div class="message__author">
                <b>${this.author}</b>
              </div>
              <div class="message__text">
                ${this.text}
              </div>
              <div class="id">
                ${this.id}
              </div>
              <div class="message__controls">
                <button class="_skipMessage" id="btnSkip${this.id}">Skip</button>
                <button class="_answerMessage" id="btnAnswer${this.id}">Answer</button>
              </div>
            </div>
            <p>`;

          ul.appendChild(li);
          let btnSkip = document.getElementById("btnSkip" + this.id);
          btnSkip.addEventListener('click', this.SkipMessage);
          let btnAnswer = document.getElementById("btnAnswer" + this.id);
          btnAnswer.addEventListener('click', this.AnswerMessage);
        }

        renderForm() {
          let li = document.getElementById(this.id);

          let answerForm = document.createElement('form');
          answerForm.id = "form" + this.id;
          answerForm.onsubmit = (e) => {
            e.preventDefault();

            let date = formatDate(new Date());
            let message = answerForm.message.value;
            let author = answerForm.author.value;

            let answerObj = new Answer(_latestId++, author, message, date, [], this.id);
            this.SendAnswer(answerObj);
          }
          answerForm.innerHTML = `
              <label for="author">
                <span>Author</span>
                <select name="author">
                  <option value="Taras Shevchenko">Taras Shevchenko</option>
                  <option value="Ivan Franko">Ivan Franko</option>
                  <option value="Vasyl Stys">Vasyl Stys</option>
                  <option value="Oles Gonchar">Oles Gonchar</option>
                </select>
              </label>

              <label for="message">
                <span>Message</span>
                <textarea placeholder="Your Message" name="message"></textarea>
              </label>

              <button type="submit">Send Message</button>
          `
          li.appendChild(answerForm);
        }
      }

      class Answer extends Message {
        constructor(id, author, text, date, answers, parentId) {
          super(id, author, text, date, answers);
          this.parentId = parentId;
        }
      }

      function sendMessageClick(e) {
        e.preventDefault();
        let date = formatDate(new Date());
        let message = form.message.value;
        let author = form.author.value;

        let messageObj = new Message(_latestId++, author, message, date, []);
        messageObj.renderMessage(message_list);
      }

      // Help
      function formatDate(date) {
        var d = new Date(date),
          month = '' + (d.getMonth() + 1),
          day = '' + d.getDate(),
          year = d.getFullYear();

        if (month.length < 2) month = '0' + month;
        if (day.length < 2) day = '0' + day;

        return [year, month, day].join('-');
      }
    })

  </script>
</body>

</html>